diff -Naur /d/visguests/mhowison/src/H5Part-1.4.0/README H5Part-1.4.1/README
--- /d/visguests/mhowison/src/H5Part-1.4.0/README	2007-08-29 02:01:14.000000000 +0000
+++ H5Part-1.4.1/README	2008-12-12 02:55:43.118966096 +0000
@@ -1,418 +1,57 @@
-==============================================================================
-README file for H5Part configure
-==============================================================================
+For more information on using the H5Part API, see the H5Part website:
 
-+ 0. HDF5 library
------------------
+        http://www-vis.lbl.gov/Research/AcceleratorSAPP/
 
-Make sure you have a working version of the HDF5 library in your computer. If you plan
-to use parallel I/O you need to use a parallel HDF5 version. If you don't have the
-library download the sources from http://hdf.ncsa.uiuc.edu/HDF5/
 
-+ 1. Quick start (If you feel lucky...)
-----------------------------------------
-
-For many platforms, where compilers are installed in the "default" location
-and all the environment variables are set correctly, it should be sufficient 
-to type: 
-
-./configure [OPTIONS] && make [install]
-
-to have the libraries and test program compiled.
-
-
-==============================================================================
-
-
-+ 2. configure line options
-----------------------------
-
-(1) Enable options
---enable-fortran
---enable-parallel
---enable-tools
---enable-python
---enable-64 (only for AIX and Irix)
-
-(2) Setting compilers related variables manually
-To assign environment variables (e.g., CC, CFLAGS...), specify them as
-VAR=VALUE.  See below for descriptions of some of the useful variables.
-
-Compiler environment variables:
-  CC          C compiler command
-  CXX         C++ compiler command
-  FC          Fortran compiler command
-
-(3) Setting prefix for installation manually
---prefix=PREFIX         install files in PREFIX
-
-
-For more information, type:
-
-./configure --help
-
-
-==============================================================================
-
-
-+ 3. Platform specific settings for compiling libraries & test programs
-------------------------------------------------------------------------
-
-Building
-        make  : builds the libraries and test programs
-	make install: builds and installs
-        make clean : removes extraneous object files
-        make distclean : returns configuration to unconfigured state
-
-As tested on hosts:
-
-(1) Davinci <davinci.nersc.gov> (Linux"SUSE"-ia64)
----------------------------------------------------
-FIRST THING FIRST!! Type:
-
-module load intel
-to have the proper compilers set up for use.
-
-module load hdf5_par
-
-[NOTE: module load hdf5 does not work at this moment. 
-Possible installation error of HDF5 on Davinci.]
-
-
-Brief profile:
-CC = icc
-CXX = icc
-FC = ifort
-MPICC = icc
-MPICXX = icc
-MPIFC = ifort
-
-If default doesn't work, try:
-
-For C shell: 
-env CC=icc CXX=icc FC=ifort MPICC=icc MPICXX=icc MPIFC=ifort ./configure && make install
-
-For Korn or Bourne shell:
-CC=icc CXX=icc FC=ifort MPICC=icc MPICXX=icc MPIFC=ifort ./configure && make install
-
-And, of course, you should add configure options, such as --enable-fortran --enable-parallel.
-
-
-On this host, executing:
-
-For C shell: 
-env CC=icc CXX=icc FC=ifort MPICC=icc MPICXX=icc MPIFC=ifort ./configure --enable-fortran --enable-parallel && make install
-
-For Korn or Bourne shell:
-CC=icc CXX=icc FC=ifort MPICC=icc MPICXX=icc MPIFC=ifort ./configure --enable-fortran --enable-parallel && make install
-
-has functioned correctly.
-
-
-To run test program, go to test directory:
-
-(i) Serial test
-run:
-./H5testF
-./H5PartTest
-
-(ii) Parallel test
-run:
-mpirun 2 H5testFpar
-mpirun 2 H5PartTestP
-
-NOTE: Number 2 above is a arbitrary number that indicates the number of processes.
-
-
-
-
-
-(2) Jacquard <jacquard.nersc.gov> (Linux"SUSE"-x86_64)
--------------------------------------------------------
-Brief profile:
-CC = pathcc
-CXX = pathCC
-FC = pathf90
-MPICC = mpicc
-MPICXX = mpicxx
-MPIFC = mpif90
-
-
-
-If default doesn't work, try:
-
-For C shell: 
-env CC=pathcc CXX=pathCC FC=pathf90 MPICC=mpicc MPICXX=mpicxx MPIFC=mpif90 ./configure && make install
-
-For Korn or Bourne shell:
-CC=pathcc CXX=pathCC FC=pathf90 MPICC=mpicc MPICXX=mpicxx MPIFC=mpif90 ./configure && make install
-
-And, of course, you should add configure options, such as --enable-fortran --enable-parallel.
-
-
-
-On this host, executing:
-
-For C shell: 
-env CC=pathcc CXX=pathCC FC=pathf90 MPICC=mpicc MPICXX=mpicxx MPIFC=mpif90 ./configure --enable-fortran --enable-parallel && make install
-
-For Korn or Bourne shell:
-CC=pathcc CXX=pathCC FC=pathf90 MPICC=mpicc MPICXX=mpicxx MPIFC=mpif90 ./configure --enable-fortran --enable-parallel && make install
-
-has functioned correctly.
-
-
-
-To run test program, go to test directory:
-
-(i) Serial test
-run:
-./H5testF
-./H5PartTest
-
-(ii) Parallel test
-In Jacquard, we need a script to run parallel programs, since Jacquard does not support interactive parallel processing. Instead, we need to submit the task to a queue. A sample script (run_H5testFpar.scr) may look like below:
-
-+++++++++++++++++++++++++++++++++++++++
-#!/bin/csh
-#PBS -l nodes=1:ppn=2,walltime=00:05:00
-#PBS -N  H5testFpar
-#PBS -o H5testFpar.out
-#PBS -e H5testFpar.err
-#PBS -q debug
-#PBS -A mpccc
-#PBS -V
-
-setenv PBS_OWORKDIR /home/H5Part/test
-
-cd $PBS_O_WORKDIR
-mpirun -np 2 ./H5testFpar
-+++++++++++++++++++++++++++++++++++++++
-
-Then, we need to submit the task to a queue by running:
-
-qsub run_H5testFpar.scr
-
-After processed, the result will appear in H5testFpar.out, and error messages will appear in H5testFpar.err.
-
-
-
-
-
-(3) Bassi <bassi.nersc.ogv> (AIX5.3.0.0-Power 3)
--------------------------------------------------
-FIRST THING FIRST!! Type:
-
-module load gcc
-
-to have the proper compilers set up for use.
-
-Brief profile:
-CC = cc_r
-CXX = cc_r
-FC = xlf_r
-MPICC = mpcc_r
-MPICXX = mpcc_r
-MPIFC = mpxlf_r
-
-
-
-If default doesn't work, try:
-
-For C shell: 
-env CC=cc_r CXX=cc_r FC=xlf_r MPICC=mpcc_r MPICXX=mpcc_r MPIFC=mpxlf_r ./configure && make install
-
-For Korn or Bourne shell:
-CC=cc_r CXX=cc_r FC=xlf_r MPICC=mpcc_r MPICXX=mpcc_r MPIFC=mpxlf_r ./configure && make install
-
-And, of course, you should add configure options, such as --enable-fortran --enable-parallel.
-
-
-
-On this host, executing:
-
-For C shell: 
-env CC=cc_r CXX=cc_r FC=xlf_r MPICC=mpcc_r MPICXX=mpcc_r MPIFC=mpxlf_r ./configure --enable-fortran --enable-parallel && make install
-
-For Korn or Bourne shell:
-CC=cc_r CXX=cc_r FC=xlf_r MPICC=mpcc_r MPICXX=mpcc_r MPIFC=mpxlf_r ./configure --enable-fortran --enable-parallel && make install
-
-has functioned correctly.
-
-
-
-To run test program, go to test directory:
-
-(i) Serial test
-run:
-./H5testF
-./H5PartTest
-
-(ii) Parallel test
-run:
-unsetenv MP_SINGLE_THREAD
-poe ./H5PartTestP -procs 2 -nodes 1
-poe ./H5testFpar -procs 2 -nodes 1
-
-For more details on how to run parallel programs on Bassi, go to:
-
-http://www.nersc.gov/nusers/resources/bassi/running_jobs/
-
-
-
-
-
-(4) Starsky <starsky.lbl.gov> (Darwin8.5.0-PowerPC)
-----------------------------------------------------
-FIRST THING FIRST!! Set environment variables: (in tcsh)
-
-setenv LD_LIBRARY_PATH /usr/local/g95/lib/gcc-lib/powerpc-apple-darwin8.5.0/4.0.3/
-setenv PATH ${PATH}:/usr/local/g95/bin
-
-NOTE: This environment variable setting is specifit to Starsky. It is to make configure find the fortran compiler.
-
-Brief profile:
-CC = gcc
-CXX = g++
-FC = g95
-
-
-
-If default doesn't work, try:
-
-For C shell: 
-env CC=gcc CXX=g++ FC=g95 ./configure && make install
-
-For Korn or Bourne shell:
-CC=gcc CXX=g++ FC=g95 ./configure && make install
-
-And, of course, you should add configure options, such as --enable-fortran --enable-parallel.
-
-
-
-On this host, executing:
-
-For C shell: 
-env CC=gcc CXX=g++ FC=g95 ./configure --enable-fortran && make install
-
-For Korn or Bourne shell:
-CC=gcc CXX=g++ FC=g95 ./configure --enable-fortran && make install
-
-has functioned correctly.
-
-
-
-To run test program, go to test directory:
-
-(i) Serial test
-run:
-./H5testF
-./H5PartTest
-
-
-
-
-
-(5) Linux AMD64 Visualization group workstations (Linux"SUSE"-x86_64)
----------------------------------------------------------
-Brief profile:
-CC = gcc
-CXX = g++
-FC = g95
-
-
-
-If default doesn't work, try:
-
-For C shell: 
-env CC=gcc CXX=g++ FC=g95 ./configure && make install
-
-For Korn or Bourne shell:
-CC=gcc CXX=g++ FC=g95 ./configure && make install
-
-And, of course, you should add configure options, such as --enable-fortran --enable-parallel.
-
-
-
-On this host, executing:
-
-For C shell: 
-env CC=gcc CXX=g++ FC=g95 ./configure --enable-fortran && make install
-
-For Korn or Bourne shell:
-CC=gcc CXX=g++ FC=g95 ./configure --enable-fortran && make install
-
-has functioned correctly.
-
-
-
-To run test program, go to test directory:
-
-(i) Serial test
-run:
-./H5testF
-./H5PartTest
-
-
-(6) Cray XT3 @ CSCS gele
-
-  1) modules/3.1.6         9) PrgEnv-pgi/1.4.26    17) xt-lustre-ss/1.4.26
-  2) MySQL/4.0.26         10) xt-pbs/5.3.4         18) Base-opts/1.4.26
-  3) acml/3.0             11) xt-service/1.4.26    19) subversion/1.3.2
-  4) pgi/6.1.4            12) xt-libc/1.4.26       20) zlib/1.2.3
-  5) totalview/7.2.0      13) xt-os/1.4.26         21) szip/2.0
-  6) xt-libsci/1.4.26     14) xt-catamount/1.4.26  22) hdf5/1.6.5
-  7) xt-mpt/1.4.26        15) xt-boot/1.4.26
-  8) xt-pe/1.4.26         16) xt-crms/1.4.26
-
-
-CFLAGS="-I$H5HOME/include -DF77_SINGLE_UNDERSCORE" LDFLAGS="-L$H5HOME/lib -L$ZHOME/lib" ./configure --enable-parallel --enable-fortran
-
-
-(7) merlin00 / merlin3 
-
-Currently Loaded Modulefiles:
-  1) hdf5/hdf5-1.6.5            2) root/root-5.10.00          3) mpi/mpich2-1.0.3-pgi-6.1   4) pgi/pgi_64-6.1
-
-FC=mpif90 ./configure --enable-parallel --enable-fortran
-
-
-
-
-
-
-
-==============================================================================
-
-
-+ 4. Trouble shooting (Things to check for...)
---------------------------------------------
-(0) Have you set the LD_LIBRARY_PATH?
----Some systems require the user to manually set the environment variable, LD_LIBRARY_PATH. To do so:
-
-set the environment variable HDF5ROOT or PHDF5ROOT to point to your installation of HDF5 (serial and/or parallel respectively).
-
-For Korn or Bourne shell:
-	LD_LIBRARY_PATH=${LD_LIBRARY_PATH}:${HDF5ROOT}/lib;export LD_LIBRARY_PATH
-	LD_LIBRARY_PATH=${LD_LIBRARY_PATH}:{PHDF5ROOT}/lib;export LD_LIBRARY_PATH
-
-For C shell:
-	setenv LD_LIBRARY_PATH ${LD_LIBRARY_PATH}:${HDF5ROOT}/lib
-	setenv LD_LIBRARY_PATH ${LD_LIBRARY_PATH}:${PHDF5ROOT}/lib
-
-Note that the values of HDF5ROOT & PHDF5ROOT will be in the "summary" section when you run configure.
-
-Not properly set LD_LIBRARY_PATH value may result in a runtime error:
-
-./H5PartTest: error while loading shared libraries: libhdf5.so.0: cannot open shared object file: No such file or directory
-
-(1) Are the compilers set correctly? 
----Check with: which COMPILER
-
-(2) Have you installed HDF5?
----You can get it at: http://vis.lbl.gov/Research/AcceleratorSAPP/index.html
-
-(3) Have you loaded the proper modules? 
----It is necessary in Davinci & Bassi, and configure && make install may not work without it.
+Motivation
+----------
 
+Particle based simulations of accelerator beam-lines, especially in six
+dimensional phase space, generate vast amounts of data. Even though a subset
+of statistical information regarding phase space or analysis needs to be
+preserved, reading and writing such enormous restart files on massively
+parallel supercomputing systems remains challenging.
+
+H5Part is a very simple data storage schema and provides an API that
+simplifies the reading/writing of the data to the HDF5 file format. An
+important foundation for a stable visualization and data analysis environment
+is a stable and portable file storage format and its associated APIs. The
+presence of a "common file storage format," including associated APIs, will
+help foster a fundamental level of interoperability across the project's
+software infrastructure. It will also help ensure that key data analysis
+capabilities are present during the earliest phases of the software development
+effort.
+
+H5Part is built on top of the HDF5 (Hierarchical Data Format) library. HDF5
+offers a self-describing machine-independent binary file format that supports
+scalable parallel I/O performance for MPI codes on a variety of supercomputing
+systems, and works equally well on laptop computers. The API is available for
+C, C++, and Fortran codes. The H5Part file format and APIs enable disparate
+research groups with different simulation implementations to transparently
+share datasets and data analysis tools. For instance, the common file format
+will enable groups that depend on completely different simulation
+implementations to share data analysis tools.
+
+
+File Organization and API
+-------------------------
+
+The proposed file storage format uses HDF5 for the lowlevel file storage and a
+simple API to provide a high-level interface to that file format. A programmer
+can either use the H5Part API to access the data files or write directly to the
+file format using some simple conventions for organizing and naming the objects
+stored in the file.
+
+In order to store Particle Data in the HDF5 file format, we have formalized the
+hierarchical arrangement of the datasets and naming conventions for the groups
+and associated datasets. The sample H5Part API formally encodes these
+conventions in order to provide a simple and uniform way to access these files
+from C, C++, and Fortran codes. The API makes it easier to write very portable
+data adaptors for visualization tools in order to expand the number of tools
+available to access the data. Even so, anyone can use the HDF5 h5ls utility to
+examine the organization of the H5Part files and even write their own
+HDF5-based interface for reading and writing the file format. The standards
+offered by the sample API are completely independent of the standard for
+organizing data within the file.The file format supports the storage of
+multiple timesteps of datasets that contain multiple fields. 
 
diff -Naur /d/visguests/mhowison/src/H5Part-1.4.0/src/H5Block.c H5Part-1.4.1/src/H5Block.c
--- /d/visguests/mhowison/src/H5Part-1.4.0/src/H5Block.c	2007-08-29 01:44:48.000000000 +0000
+++ H5Part-1.4.1/src/H5Block.c	2008-12-01 22:07:57.454027521 +0000
@@ -142,6 +142,9 @@
 	b->memshape = -1;
 	b->field_group_id = -1;
 	b->have_layout = 0;
+	b->chunk[0] = 0;
+	b->chunk[1] = 0;
+	b->chunk[2] = 0;
 
 	f->close_block = _close;
 
@@ -260,7 +263,7 @@
 	size_t n = sizeof (struct H5BlockPartition) / sizeof (h5part_int64_t);
 
 	MPI_Type_contiguous ( n, MPI_LONG_LONG, &partition_m );
-        MPI_Type_commit ( &partition_m );
+	  MPI_Type_commit ( &partition_m );
 
 	MPI_Allgather ( partition, 1, partition_m, layout, 1, partition_m,
 			f->comm );
@@ -305,8 +308,8 @@
 }
 
 #define _NO_GHOSTZONE(p,q) ( (p->i_end < q->i_start) \
-  		        ||   (p->j_end < q->j_start) \
-		        ||   (p->k_end < q->k_start) )
+  			  ||   (p->j_end < q->j_start) \
+			  ||   (p->k_end < q->k_start) )
 
 
 /*!
@@ -577,11 +580,11 @@
 	memset ( p_begin, 0, sizeof ( *p_begin ) );
 
 	for ( proc_p = 0, p = b->write_layout;
-	      proc_p < f->nprocs-1;
-	      proc_p++, p++ ) {
+		proc_p < f->nprocs-1;
+		proc_p++, p++ ) {
 		for ( proc_q = proc_p+1, q = &b->write_layout[proc_q];
-		      proc_q < f->nprocs;
-		      proc_q++, q++ ) {
+			proc_q < f->nprocs;
+			proc_q++, q++ ) {
 
 			if ( _have_ghostzone ( p, q ) ) {
 				p_el = (struct list*) malloc ( sizeof ( *p_el ) );
@@ -632,8 +635,8 @@
 
 	_H5Part_print_debug ("Layout defined by user:");
 	for ( proc_p = 0, p = b->user_layout;
-	      proc_p < f->nprocs;
-	      proc_p++, p++ ) {
+		proc_p < f->nprocs;
+		proc_p++, p++ ) {
 		_H5Part_print_debug (
 			"PROC[%d]: proc[%d]: %lld:%lld, %lld:%lld, %lld:%lld  ",
 			f->myproc, proc_p,
@@ -644,8 +647,8 @@
 
 	_H5Part_print_debug ("Layout after dissolving ghost-zones:");
 	for ( proc_p = 0, p = b->write_layout;
-	      proc_p < f->nprocs;
-	      proc_p++, p++ ) {
+		proc_p < f->nprocs;
+		proc_p++, p++ ) {
 		_H5Part_print_debug (
 			"PROC[%d]: proc[%d]: %lld:%lld, %lld:%lld, %lld:%lld  ",
 			f->myproc, proc_p,
@@ -740,6 +743,33 @@
 /*!
   \ingroup h5block_c_api
 
+  Define the chunk dimensions and enable chunking in the underlying
+  HDF5 dataset.
+
+  \return \c H5PART_SUCCESS on success
+*/
+h5part_int64_t
+H5BlockDefine3DChunk(
+	H5PartFile *f,			/*!< IN: File handle */
+	const h5part_int64_t *dims      /*!< IN: array containing
+						 the chunk dimensions */
+	) {
+
+	SET_FNAME ( "H5BlockDefine3DChunk" );
+	INIT( f );
+
+	struct H5BlockStruct *b = f->block;
+
+	b->chunk[0] = (hsize_t)dims[2];
+	b->chunk[1] = (hsize_t)dims[1];
+	b->chunk[2] = (hsize_t)dims[0];
+
+	return H5PART_SUCCESS;
+}
+
+/*!
+  \ingroup h5block_c_api
+
   Return partition of processor \c proc as specified with
   \c H5BlockDefine3dLayout().
 
@@ -874,7 +904,14 @@
 	}
 
 	if ( b->blockgroup < 0 ) {
+#if H5_VERS_MAJOR == 1 && H5_VERS_MINOR == 8
+		hid_t herr = H5Gopen2 (
+				f->timegroup,
+				H5BLOCK_GROUPNAME_BLOCK,
+				H5P_DEFAULT );
+#else
 		hid_t herr = H5Gopen ( f->timegroup, H5BLOCK_GROUPNAME_BLOCK );
+#endif
 		if ( herr < 0 ) return HANDLE_H5G_OPEN_ERR ( H5BLOCK_GROUPNAME_BLOCK );
 		b->blockgroup = herr;
 	}
@@ -920,7 +957,11 @@
 	if ( ! _have_object ( b->blockgroup, name ) )
 		return HANDLE_H5PART_NOENT_ERR ( name );
 
+#if H5_VERS_MAJOR == 1 && H5_VERS_MINOR == 8
+	herr_t herr = H5Gopen2 ( b->blockgroup, name, H5P_DEFAULT );
+#else
 	herr_t herr = H5Gopen ( b->blockgroup, name );
+#endif
 	if ( herr < 0 ) return HANDLE_H5G_OPEN_ERR ( name );
 
 	b->field_group_id = herr;
@@ -1045,12 +1086,17 @@
 _read_data (
 	H5PartFile *f,			/*!< IN: file handle */
 	const char *name,		/*!< IN: name of dataset to read */
-	h5part_float64_t *data		/*!< OUT: ptr to read buffer */
+	void *data,			/*!< OUT: ptr to read buffer */
+	hid_t type      		/*!< IN: data type */
 	) {
 
 	struct H5BlockStruct *b = f->block;
 
+#if H5_VERS_MAJOR == 1 && H5_VERS_MINOR == 8
+	hid_t dataset_id = H5Dopen2 ( b->field_group_id, name, H5P_DEFAULT );
+#else
 	hid_t dataset_id = H5Dopen ( b->field_group_id, name );
+#endif
 	if ( dataset_id < 0 ) return HANDLE_H5D_OPEN_ERR ( name );
 
 	h5part_int64_t herr = _select_hyperslab_for_reading ( f, dataset_id );
@@ -1058,7 +1104,7 @@
 
 	herr = H5Dread ( 
 		dataset_id,
-		H5T_NATIVE_DOUBLE,
+		type,
 		f->block->memshape,
 		f->block->diskshape,
 		H5P_DEFAULT,
@@ -1076,13 +1122,112 @@
 
   Read a 3-dimensional field \c name into the buffer starting at \c data from
   the current time-step using the defined field layout. Values are real valued
-  scalars.
+  scalars (64-bit).
 
   You must use the FORTRAN indexing scheme to access items in \c data.
 
   \return \c H5PART_SUCCESS or error code
 */
 h5part_int64_t
+H5BlockReadFieldFloat64 (
+	H5PartFile *f,			/*!< IN: file handle */
+	const char *name,		/*!< IN: name of dataset to read */
+	h5part_float64_t *data		/*!< OUT: ptr to read buffer */
+	) {
+
+	SET_FNAME ( "H5BlockReadFieldFloat64" );
+	INIT ( f );
+	CHECK_TIMEGROUP ( f );
+	CHECK_LAYOUT ( f );
+
+	h5part_int64_t herr = _open_field_group ( f, name );
+	if ( herr < 0 ) return herr;
+
+	herr = _read_data ( f, "0", data, H5T_NATIVE_DOUBLE );
+	if ( herr < 0 ) return herr;
+
+	herr = _close_field_group ( f );
+	if ( herr < 0 ) return herr;
+
+	return H5PART_SUCCESS;
+}
+
+/*!
+  \ingroup h5block_c_api
+
+  Read a 3-dimensional field \c name into the buffer starting at \c data from
+  the current time-step using the defined field layout. Values are real valued
+  scalars (32-bit).
+
+  You must use the FORTRAN indexing scheme to access items in \c data.
+
+  \return \c H5PART_SUCCESS or error code
+*/
+h5part_int64_t
+H5BlockReadFieldFloat32 (
+	H5PartFile *f,			/*!< IN: file handle */
+	const char *name,		/*!< IN: name of dataset to read */
+	h5part_float32_t *data		/*!< OUT: ptr to read buffer */
+	) {
+
+	SET_FNAME ( "H5BlockReadFieldFloat32" );
+	INIT ( f );
+	CHECK_TIMEGROUP ( f );
+	CHECK_LAYOUT ( f );
+
+	h5part_int64_t herr = _open_field_group ( f, name );
+	if ( herr < 0 ) return herr;
+
+	herr = _read_data ( f, "0", data, H5T_NATIVE_FLOAT );
+	if ( herr < 0 ) return herr;
+
+	herr = _close_field_group ( f );
+	if ( herr < 0 ) return herr;
+
+	return H5PART_SUCCESS;
+}
+
+/*!
+  \ingroup h5block_c_api
+
+  Read a 3-dimensional field \c name into the buffer starting at \c data from
+  the current time-step using the defined field layout. Values are integer
+  valued scalars (64-bit).
+
+  You must use the FORTRAN indexing scheme to access items in \c data.
+
+  \return \c H5PART_SUCCESS or error code
+*/
+h5part_int64_t
+H5BlockReadFieldInt64 (
+	H5PartFile *f,			/*!< IN: file handle */
+	const char *name,		/*!< IN: name of dataset to read */
+	h5part_int64_t *data		/*!< OUT: ptr to read buffer */
+	) {
+
+	SET_FNAME ( "H5BlockReadFieldInt64" );
+	INIT ( f );
+	CHECK_TIMEGROUP ( f );
+	CHECK_LAYOUT ( f );
+
+	h5part_int64_t herr = _open_field_group ( f, name );
+	if ( herr < 0 ) return herr;
+
+	herr = _read_data ( f, "0", data, H5T_NATIVE_INT64 );
+	if ( herr < 0 ) return herr;
+
+	herr = _close_field_group ( f );
+	if ( herr < 0 ) return herr;
+
+	return H5PART_SUCCESS;
+}
+
+/*!
+  \ingroup h5block_c_api
+
+  This funciton is deprecated in favor of \c H5BlockReadFieldFloat64.
+*/
+h5part_int64_t
 H5Block3dReadScalarField (
 	H5PartFile *f,			/*!< IN: file handle */
 	const char *name,		/*!< IN: name of dataset to read */
@@ -1097,7 +1242,7 @@
 	h5part_int64_t herr = _open_field_group ( f, name );
 	if ( herr < 0 ) return herr;
 
-	herr = _read_data ( f, "0", data );
+	herr = _read_data ( f, "0", data, H5T_NATIVE_DOUBLE );
 	if ( herr < 0 ) return herr;
 
 	herr = _close_field_group ( f );
@@ -1135,11 +1280,11 @@
 	h5part_int64_t herr = _open_field_group ( f, name );
 	if ( herr < 0 ) return herr;
 
-	herr = _read_data ( f, "0", x_data );
+	herr = _read_data ( f, "0", x_data, H5T_NATIVE_DOUBLE );
 	if ( herr < 0 ) return herr;
-	herr = _read_data ( f, "1", y_data );
+	herr = _read_data ( f, "1", y_data, H5T_NATIVE_DOUBLE );
 	if ( herr < 0 ) return herr;
-	herr = _read_data ( f, "2", z_data );
+	herr = _read_data ( f, "2", z_data, H5T_NATIVE_DOUBLE );
 	if ( herr < 0 ) return herr;
 
 	herr = _close_field_group ( f );
@@ -1287,7 +1432,16 @@
 		f->block->blockgroup = -1;
 	}
 
+#if H5_VERS_MAJOR == 1 && H5_VERS_MINOR == 8
+	herr = H5Gcreate2 (
+		    f->timegroup,
+		    H5BLOCK_GROUPNAME_BLOCK,
+		    H5P_DEFAULT,
+		    H5P_DEFAULT,
+		    H5P_DEFAULT );
+#else
 	herr = H5Gcreate ( f->timegroup, H5BLOCK_GROUPNAME_BLOCK, 0 );
+#endif
 	if ( herr < 0 ) return HANDLE_H5G_CREATE_ERR ( H5BLOCK_GROUPNAME_BLOCK );
 
 	f->block->blockgroup = herr;
@@ -1324,7 +1478,16 @@
 	if ( _have_object ( b->blockgroup, name ) )
 		return  HANDLE_H5PART_GROUP_EXISTS_ERR ( name );
 
+#if H5_VERS_MAJOR == 1 && H5_VERS_MINOR == 8
+	herr_t herr = H5Gcreate2 (
+		    b->blockgroup,
+		    name,
+		    H5P_DEFAULT,
+		    H5P_DEFAULT,
+		    H5P_DEFAULT );
+#else
 	herr_t herr = H5Gcreate ( b->blockgroup, name, 0 );
+#endif
 	if ( herr < 0 ) return HANDLE_H5G_CREATE_ERR ( name );
 	b->field_group_id = herr;
 
@@ -1342,24 +1505,47 @@
 _write_data (
 	H5PartFile *f,			/*!< IN: file handle */
 	const char *name,		/*!< IN: name of dataset to write */
-	const h5part_float64_t *data	/*!< IN: data to write */
+	const void *data,		/*!< IN: data to write */
+	const hid_t type		/*!< IN: data type */
 	) {
 
 	herr_t herr;
 	hid_t dataset;
+	hid_t create_prop = H5P_DEFAULT;
 	struct H5BlockStruct *b = f->block;
 
+	if ( b->chunk[0] > 0 &&
+	     b->chunk[1] > 0 &&
+	     b->chunk[2] > 0)
+	{
+		create_prop = H5Pcreate( H5P_DATASET_CREATE );
+		herr = H5Pset_chunk ( create_prop, 3, b->chunk );
+		if ( herr < 0 ) return HANDLE_H5P_SET_CHUNK_ERR;
+	}
+
+#if H5_VERS_MAJOR == 1 && H5_VERS_MINOR == 8
+	dataset = H5Dcreate2 (
+		b->field_group_id,
+		name,
+		type,
+		b->shape,
+		H5P_DEFAULT,
+		create_prop,
+		H5P_DEFAULT );
+#else
 	dataset = H5Dcreate (
 		b->field_group_id,
 		name,
-		H5T_NATIVE_DOUBLE,
+		type,
 		b->shape, 
-		H5P_DEFAULT );
+		create_prop );
+#endif
+
 	if ( dataset < 0 ) return HANDLE_H5D_CREATE_ERR ( name, f->timestep );
 
 	herr = H5Dwrite ( 
 		dataset,
-		H5T_NATIVE_DOUBLE,
+		type,
 		b->memshape,
 		b->diskshape,
 		H5P_DEFAULT,
@@ -1369,6 +1555,47 @@
 	herr = H5Dclose ( dataset );
 	if ( herr < 0 ) return HANDLE_H5D_CLOSE_ERR;
 
+	if ( create_prop != H5P_DEFAULT ) {
+		herr = H5Pclose ( create_prop );
+		if ( herr < 0 ) return HANDLE_H5P_CLOSE_ERR ( "create_prop" );
+	}
+
+	return H5PART_SUCCESS;
+}
+
+/*!
+  \ingroup h5block_c_api
+
+  Write a 3-dimensional field \c name from the buffer starting at \c data 
+  to the current time-step using the defined field layout. Values are real 
+  valued scalars (64-bit).
+
+  You must use the FORTRAN indexing scheme to access items in \c data.
+
+  \return \c H5PART_SUCCESS or error code
+*/
+h5part_int64_t
+H5BlockWriteFieldFloat64 (
+	H5PartFile *f,			/*!< IN: file handle */
+	const char *name,		/*!< IN: name of dataset to write */
+	const h5part_float64_t *data	/*!< IN: scalar data to write */
+	) {
+
+	SET_FNAME ( "H5BlockWriteFieldFloat64" );
+	INIT ( f );
+	CHECK_WRITABLE_MODE ( f );
+	CHECK_TIMEGROUP ( f );
+	CHECK_LAYOUT ( f );
+
+	h5part_int64_t herr = _create_field_group ( f, name );
+	if ( herr < 0 ) return herr;
+
+	herr = _write_data ( f, "0", data, H5T_NATIVE_DOUBLE );
+	if ( herr < 0 ) return herr;
+
+	herr = _close_field_group ( f );
+	if ( herr < 0 ) return herr;
+
 	return H5PART_SUCCESS;
 }
 
@@ -1377,13 +1604,78 @@
 
   Write a 3-dimensional field \c name from the buffer starting at \c data 
   to the current time-step using the defined field layout. Values are real 
-  valued scalars.
+  valued scalars (32-bit).
 
   You must use the FORTRAN indexing scheme to access items in \c data.
 
   \return \c H5PART_SUCCESS or error code
 */
 h5part_int64_t
+H5BlockWriteFieldFloat32 (
+	H5PartFile *f,			/*!< IN: file handle */
+	const char *name,		/*!< IN: name of dataset to write */
+	const h5part_float32_t *data	/*!< IN: scalar data to write */
+	) {
+
+	SET_FNAME ( "H5BlockWriteFieldFloat32" );
+	INIT ( f );
+	CHECK_WRITABLE_MODE ( f );
+	CHECK_TIMEGROUP ( f );
+	CHECK_LAYOUT ( f );
+
+	h5part_int64_t herr = _create_field_group ( f, name );
+	if ( herr < 0 ) return herr;
+
+	herr = _write_data ( f, "0", data, H5T_NATIVE_FLOAT );
+	if ( herr < 0 ) return herr;
+
+	herr = _close_field_group ( f );
+	if ( herr < 0 ) return herr;
+
+	return H5PART_SUCCESS;
+}
+/*!
+  \ingroup h5block_c_api
+
+  Write a 3-dimensional field \c name from the buffer starting at \c data 
+  to the current time-step using the defined field layout. Values are integer 
+  valued scalars (64-bit).
+
+  You must use the FORTRAN indexing scheme to access items in \c data.
+
+  \return \c H5PART_SUCCESS or error code
+*/
+h5part_int64_t
+H5BlockWriteFieldInt64 (
+	H5PartFile *f,			/*!< IN: file handle */
+	const char *name,		/*!< IN: name of dataset to write */
+	const h5part_int64_t *data	/*!< IN: scalar data to write */
+	) {
+
+	SET_FNAME ( "H5BlockWriteFieldInt64" );
+	INIT ( f );
+	CHECK_WRITABLE_MODE ( f );
+	CHECK_TIMEGROUP ( f );
+	CHECK_LAYOUT ( f );
+
+	h5part_int64_t herr = _create_field_group ( f, name );
+	if ( herr < 0 ) return herr;
+
+	herr = _write_data ( f, "0", data, H5T_NATIVE_INT64 );
+	if ( herr < 0 ) return herr;
+
+	herr = _close_field_group ( f );
+	if ( herr < 0 ) return herr;
+
+	return H5PART_SUCCESS;
+}
+
+/*!
+  \ingroup h5block_c_api
+
+  This function is deprecated in favor of \c H5BlockWriteFieldFloat64.
+*/
+h5part_int64_t
 H5Block3dWriteScalarField (
 	H5PartFile *f,			/*!< IN: file handle */
 	const char *name,		/*!< IN: name of dataset to write */
@@ -1399,7 +1691,7 @@
 	h5part_int64_t herr = _create_field_group ( f, name );
 	if ( herr < 0 ) return herr;
 
-	herr = _write_data ( f, "0", data );
+	herr = _write_data ( f, "0", data, H5T_NATIVE_DOUBLE );
 	if ( herr < 0 ) return herr;
 
 	herr = _close_field_group ( f );
@@ -1439,11 +1731,11 @@
 	h5part_int64_t herr = _create_field_group ( f, name );
 	if ( herr < 0 ) return herr;
 
-	herr = _write_data ( f, "0", x_data );
+	herr = _write_data ( f, "0", x_data, H5T_NATIVE_DOUBLE );
 	if ( herr < 0 ) return herr;
-	herr = _write_data ( f, "1", y_data );
+	herr = _write_data ( f, "1", y_data, H5T_NATIVE_DOUBLE );
 	if ( herr < 0 ) return herr;
-	herr = _write_data ( f, "2", z_data );
+	herr = _write_data ( f, "2", z_data, H5T_NATIVE_DOUBLE );
 	if ( herr < 0 ) return herr;
 
 	herr = _close_field_group ( f );
@@ -1498,10 +1790,21 @@
 	h5part_int64_t herr = _open_block_group ( f );
 	if ( herr < 0 ) return herr;
 
+#if H5_VERS_MAJOR == 1 && H5_VERS_MINOR == 8
+	hid_t group_id = H5Gopen2 (
+		    f->block->blockgroup,
+		    field_name,
+		    H5P_DEFAULT );
+#else
 	hid_t group_id = H5Gopen ( f->block->blockgroup, field_name );
+#endif
 	if ( group_id < 0 ) return HANDLE_H5G_OPEN_ERR ( field_name );
 
+#if H5_VERS_MAJOR == 1 && H5_VERS_MINOR == 8
+	hid_t dataset_id = H5Dopen2 ( group_id, "0", H5P_DEFAULT );
+#else
 	hid_t dataset_id = H5Dopen ( group_id, "0" );
+#endif
 	if ( dataset_id < 0 ) return HANDLE_H5D_OPEN_ERR ( "0" );
 
  	hid_t dataspace_id = H5Dget_space ( dataset_id );
diff -Naur /d/visguests/mhowison/src/H5Part-1.4.0/src/H5Block.h H5Part-1.4.1/src/H5Block.h
--- /d/visguests/mhowison/src/H5Part-1.4.0/src/H5Block.h	2007-08-29 01:44:48.000000000 +0000
+++ H5Part-1.4.1/src/H5Block.h	2008-12-01 21:03:49.022379532 +0000
@@ -54,6 +54,27 @@
 	);
 
 h5part_int64_t
+H5BlockWriteFieldFloat64 (
+	H5PartFile *f,
+	const char *name,
+	const h5part_float64_t *data
+	);
+
+h5part_int64_t
+H5BlockWriteFieldFloat32 (
+	H5PartFile *f,
+	const char *name,
+	const h5part_float32_t *data
+	);
+
+h5part_int64_t
+H5BlockWriteFieldInt64 (
+	H5PartFile *f,
+	const char *name,
+	const h5part_int64_t *data
+	);
+
+h5part_int64_t
 H5Block3dWriteScalarField (
 	H5PartFile *f,
 	const char *name,
@@ -61,6 +82,27 @@
 	);
 
 h5part_int64_t
+H5BlockReadFieldFloat64 (
+	H5PartFile *f,
+	const char *name,
+	h5part_float64_t *data
+	);
+
+h5part_int64_t
+H5BlockReadFieldFloat32 (
+	H5PartFile *f,
+	const char *name,
+	h5part_float32_t *data
+	);
+
+h5part_int64_t
+H5BlockReadFieldInt64 (
+	H5PartFile *f,
+	const char *name,
+	h5part_int64_t *data
+	);
+
+h5part_int64_t
 H5Block3dReadScalarField (
 	H5PartFile *f,
 	const char *name,
diff -Naur /d/visguests/mhowison/src/H5Part-1.4.0/src/H5BlockTypes.h H5Part-1.4.1/src/H5BlockTypes.h
--- /d/visguests/mhowison/src/H5Part-1.4.0/src/H5BlockTypes.h	2007-08-29 01:44:48.000000000 +0000
+++ H5Part-1.4.1/src/H5BlockTypes.h	2008-12-01 22:08:11.342070307 +0000
@@ -18,6 +18,7 @@
 	struct H5BlockPartition *user_layout;
 	struct H5BlockPartition *write_layout;
 	int have_layout;
+	hsize_t chunk[3];
 
 	hid_t shape;
 	hid_t memshape;
